# coding: utf-8

"""
    Kubernetes

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: release-1.29
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime

from pydantic import BaseModel, Field, StrictInt

class EventsV1EventSeries(BaseModel):
    """
    EventSeries contain information on series of events, i.e. thing that was/is happening continuously for some time. How often to update the EventSeries is up to the event reporters. The default event reporter in \"k8s.io/client-go/tools/events/event_broadcaster.go\" shows how this struct is updated on heartbeats and can guide customized reporter implementations.  # noqa: E501
    """
    count: StrictInt = Field(..., description="count is the number of occurrences in this series up to the last heartbeat time.")
    last_observed_time: datetime = Field(..., alias="lastObservedTime", description="lastObservedTime is the time when last Event from the series was seen before last heartbeat.")
    __properties = ["count", "lastObservedTime"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> EventsV1EventSeries:
        """Create an instance of EventsV1EventSeries from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> EventsV1EventSeries:
        """Create an instance of EventsV1EventSeries from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return EventsV1EventSeries.parse_obj(obj)

        _obj = EventsV1EventSeries.parse_obj({
            "count": obj.get("count"),
            "last_observed_time": obj.get("lastObservedTime")
        })
        return _obj


