# coding: utf-8

"""
    Kubernetes

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: release-1.29
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictStr

class V1StatefulSetPersistentVolumeClaimRetentionPolicy(BaseModel):
    """
    StatefulSetPersistentVolumeClaimRetentionPolicy describes the policy used for PVCs created from the StatefulSet VolumeClaimTemplates.  # noqa: E501
    """
    when_deleted: Optional[StrictStr] = Field(default=None, alias="whenDeleted", description="WhenDeleted specifies what happens to PVCs created from StatefulSet VolumeClaimTemplates when the StatefulSet is deleted. The default policy of `Retain` causes PVCs to not be affected by StatefulSet deletion. The `Delete` policy causes those PVCs to be deleted.")
    when_scaled: Optional[StrictStr] = Field(default=None, alias="whenScaled", description="WhenScaled specifies what happens to PVCs created from StatefulSet VolumeClaimTemplates when the StatefulSet is scaled down. The default policy of `Retain` causes PVCs to not be affected by a scaledown. The `Delete` policy causes the associated PVCs for any excess pods above the replica count to be deleted.")
    __properties = ["whenDeleted", "whenScaled"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1StatefulSetPersistentVolumeClaimRetentionPolicy:
        """Create an instance of V1StatefulSetPersistentVolumeClaimRetentionPolicy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1StatefulSetPersistentVolumeClaimRetentionPolicy:
        """Create an instance of V1StatefulSetPersistentVolumeClaimRetentionPolicy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1StatefulSetPersistentVolumeClaimRetentionPolicy.parse_obj(obj)

        _obj = V1StatefulSetPersistentVolumeClaimRetentionPolicy.parse_obj({
            "when_deleted": obj.get("whenDeleted"),
            "when_scaled": obj.get("whenScaled")
        })
        return _obj


