# coding: utf-8

"""
    Kubernetes

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: release-1.29
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictInt, StrictStr

class V2HPAScalingPolicy(BaseModel):
    """
    HPAScalingPolicy is a single policy which must hold true for a specified past interval.  # noqa: E501
    """
    period_seconds: StrictInt = Field(..., alias="periodSeconds", description="periodSeconds specifies the window of time for which the policy should hold true. PeriodSeconds must be greater than zero and less than or equal to 1800 (30 min).")
    type: StrictStr = Field(..., description="type is used to specify the scaling policy.")
    value: StrictInt = Field(..., description="value contains the amount of change which is permitted by the policy. It must be greater than zero")
    __properties = ["periodSeconds", "type", "value"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V2HPAScalingPolicy:
        """Create an instance of V2HPAScalingPolicy from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V2HPAScalingPolicy:
        """Create an instance of V2HPAScalingPolicy from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V2HPAScalingPolicy.parse_obj(obj)

        _obj = V2HPAScalingPolicy.parse_obj({
            "period_seconds": obj.get("periodSeconds"),
            "type": obj.get("type"),
            "value": obj.get("value")
        })
        return _obj


